/* -*- mode: jde; c-basic-offset: 2; indent-tabs-mode: nil -*- */

package processing.parallel;
import processing.core.*;

import java.lang.reflect.*;

import hardware.jnpout32.*;

public class Parallel {

	PApplet parent;
	static short Addr;
	static pPort lpt;

	static short dAddr = 0x378;
	
	float time_fac = (3195/100); // (658/100)  *4= ~200 s, Basis 50 s
	
	public Parallel(PApplet parent) {
		this(parent, dAddr);
	}

	public Parallel(PApplet parent, int iAddr) {
		//if (port != null) port.close();
		this.parent = parent;
		//parent.attach(this);
		this.time_fac=time_fac;

		this.Addr = (short) iAddr;
		lpt = new pPort();

	}
	

	public void stop() {
		dispose();
	}

	/**
	 * Used by PApplet to shut things down.
	 */
	public void dispose() {
		lpt = null;
	}
	
	
	/**
	 * This will handle both ints, bytes and chars transparently.
	 */
	 
	public void write(String data) {
		byte[] data_array = data.getBytes();
		int dat_length=data_array.length;
		int z;
		for (z=0; z<dat_length; z++) {
			lpt.output(this.Addr, (short) data_array[z]);
		}
	}
	
	public void setTimeFac(float fac) {
		this.time_fac = fac;
	}
	
	public float getTimeFac() {
		return this.time_fac;
	}
	
	public void write(byte[] data_array) {
		int z, dly, dat_length=data_array.length;
		byte cur_stat = 0x00;
		int value;
		for (z=0; z<dat_length; z++) {
			for (dly=0; dly<this.time_fac; dly++) {
				cur_stat ^= 0xff;
				value = data_array[z] & cur_stat;
				lpt.output(this.Addr, (short) value);
			}
		}
	}
	
	public void writeTimebased(int[] data_array) {
		int z, dly, waitstates, dat_length=data_array.length;
		byte cur_stat = 0x00;
		int value;
		for (z=0; z < dat_length; z+=2) {
			waitstates= (int) ( (float)data_array[z+1] *this.time_fac);
			for (dly=0; dly < waitstates; dly++) {
				cur_stat ^= 0xff;
				value = data_array[z] & cur_stat;
				lpt.output(this.Addr, (short) value);
			}
		}
	}
	
	public void writeSpybotCommand(int low_byte, int hi_byte) {
		byte parity=0,
		  cur_stat= 0x00;
		int z, value, 
		  waitstates = (int) (this.time_fac * 4);
		
		// startbit
		writeSpyBit(255);
		
		// datenbits
		for (z=0; z<8; z++) {
			value = (low_byte & 0x01) * 255;
			parity+= (low_byte & 0x01);
			low_byte >>= 1;
			
			writeSpyBit(value);
		}
		// Parity
		parity %= 2;
		writeSpyBit(parity*255);
		
		// stopBit
		writeSpyBit(255);
		//startBit
		writeSpyBit(255);
		
		// datenbits
		parity=0;
		for (z=0; z<8; z++) {
			value = (low_byte & 0x01) * 255;
			parity+= (low_byte & 0x01);
			low_byte >>= 1;
			
			writeSpyBit(value);
		}
		//parity
		parity %= 2;
		writeSpyBit(parity*255);
		// stopbit
		writeSpyBit(255);
		lpt.output(this.Addr, (short)0);
	}
	
	public void writeSpyBit(int value) {
		int dly, cur_stat=0x00, val,
			waitstates = (int) (this.time_fac);
		
		for (dly=0; dly<waitstates; dly++) {
			cur_stat ^= 0xff;
			val=value & cur_stat;
			lpt.output(this.Addr, (short)val);
		}
	}
		
	public void write(int what) {
		lpt.output(this.Addr, (short) what);
	}
	
	public int read() {
		return (short) lpt.input(this.Addr);
	}
}
